#!/bin/bash

#startDate = "19970621113000" ;
#endDate = "19970622023000" ;
new_input=1


if [ $new_input = 0 ] ; then
   ncdump -h setup/cas.nc > tmp
   surfaceType="land" ;  surfaceForcing="0" ;  forcingForcingWind="z0"
else
   ncdump -h cas.nc | sed -e 's/qvadv/qadv/g' -e 's/^.*.://' > tmp
   forc_ustar=0 ; forc_u=0 ; forc_v=0 ; z0=0.
fi


\rm cas.def ; touch cas.def

for var in \
	adv_temp adv_theta adv_thetal \
	rad_temp rad_theta rad_thetal \
	adv_qv adv_qt adv_rv adv_rt \
	forc_omega forc_w forc_geo \
       	nudging_temp nudging_theta nudging_thetal \
	nudging_qv nudging_qt nudging_rv nudging_rt \
       	nudging_u nudging_v \
       	p_nudging_u p_nudging_v p_nudging_temp p_nudging_theta p_nudging_thetal \
       	z_nudging_u z_nudging_v z_nudging_temp z_nudging_theta z_nudging_thetal \
       	p_nudging_qv p_nudging_qt p_nudging_rv p_nudging_rt \
       	z_nudging_qv z_nudging_qt z_nudging_rv z_nudging_rt \
	zorog z0  \
	surfaceType surfaceForcing forcingForcingWind \
	forc_ustar forc_u forc_v \
	; do

	val=`grep "^$var =" tmp | tail -1 | cut -d= -f2 | awk ' { print $1 } ' | sed -e 's/"//g' `
	echo $var =$val
	# Regarder le probleme de trad
	if [ "$val" != "" ] ; then
	varname=$var
		case $var in
			surfaceForcing) varname=ok_flux_surf ; if [ $val = ts ] ; then val=n ; else val=y ; fi ;; 
			surfaceType) varname=nat_surf
				case `echo $val | sed -e 's/ //g'` in
					land) val=1 ;;
					ocean) val=0 ;;
					seaice) val=3 ;;
					landice) val=2 ;;
				esac ;;
			trad) varname=iflag_radia
				case $val in
					adv) val=0 ;;
					*) val=1
				esac
		esac
		echo $varname=$val >> cas.def
	fi
done

############# coordonnees #############################################
for coord in lon lat ; do ncdump cas.nc -v $coord | grep $coord | tail -1 | awk ' { print "r'$coord'="$3 } ' >> cas.def ; done
for coord in lon lat ; do ncdump cas.nc -v $coord | grep $coord | tail -1 | awk ' { print "r'$coord'="$3 } ' ; done

############# Pression de surface #####################################
# Pour le moment, on ne gere pas les changement de pression de surface
# Cette commande rale. C'est domage
psurf=`cdo output -selvar,ps cas.nc | head -1`
echo psurf=$psurf | sed -e 's/ //g' >> cas.def

############# Gestion du calendrier ###################################
time_i=`ncdump -h cas.nc | grep startDate | cut -d\" -f2`
time_f=`ncdump -h cas.nc | grep endDate | cut -d\" -f2`
yr_i=`echo $time_i | cut -c1-4`
mo_i=`echo $time_i | cut -c5-6`
da_i=`echo $time_i | cut -c7-8`
hr_i=`echo $time_i | cut -c9-10`
mn_i=`echo $time_i | cut -c11-12`
sc_i=`echo $time_i | cut -c13-14`
echo DATE INI $yr_i $mo_i  $da_i $hr_i $mn_i $sc_i $time_i
yr_f=`echo $time_f | cut -c1-4`
mo_f=`echo $time_f | cut -c5-6`
da_f=`echo $time_f | cut -c7-8`
hr_f=`echo $time_f | cut -c9-10`
mn_f=`echo $time_f | cut -c11-12`
sc_f=`echo $time_f | cut -c13-14`
echo DATE END $yr_f $mo_f  $da_f $hr_f $mn_f $sc_f $time_f
(( yr_d = $yr_f - $yr_i ))
(( mo_d = $mo_f - $mo_i ))
(( da_d = $da_f - $da_i ))
(( hr_d = $hr_f - $hr_i ))
(( mn_d = $mn_f - $mn_i ))
(( sc_d = $sc_f - $sc_i ))

echo PREVOIR DE PASSER AU CALENDRIER VRAI
calend=360

# Jour compte depuis le debut de l'annee
if [ $calend = 360 ] ; then
	d0mo=( 0 30 60 90 120 150 180 210 240 270 300 330 )
	yr_length=360
fi
day_i=$(( d0mo[$(( $mo_i - 1 ))] +  $da_i ))

# Longeur de la simulation en jours, incluant la prise en compte des heures
hour_i=$(( $day_i * 24 + $hr_i ))
hour_f=$(( $(( d0mo[$(( $mo_f - 1 ))] +  $da_f + $yr_d * $yr_length )) * 24 + $hr_f ))
echo HOUR $hour_i $hour_f $da_i $da_f
nday=$(( $(( $hour_f - $hour_i -1 )) / 24 + 1 ))



echo dayref=$(( d0mo[$(( $mo_i - 1 ))] +  $da_i )) >> cas.def
echo anneeref=$yr_i >> cas.def
echo nday=$nday >> cas.def
echo time_ini=`echo $hr_i $mn_i $sc_i | awk ' { print ( $1 * 3600 + $2 * 60 + $3 ) / 3600. } '`  >> cas.def

cas=`basename \`( cd .. ; pwd )\``
echo CAS $cas

# Specificites du cas Sandu. En cous d'instruction
if [ $cas = SANDU ] ; then
	sed -e "s/anneeref=2007/anneeref=2006/" -e "s/time_ini=.*.$/time_ini=18/" -i cas.def
	cat <<eod>> cas.def
iflag_z0_oce=-1
z0min=0.002
eod
fi


